// D import file generated from 'sqlite/database.d'
module sqlite.database;
private import std.string;

private import etc.c.sqlite3;

public import std.variant;

private import std.conv;

private import core.exception : RangeError;

public import sqlite.table;

public import sqlite.statement;

public import sqlite.exception;

debug (1)
{
	private import std.stdio;

}
@system Database executeScript(in string databasePath, in string[] lines...);

final class Database
{
	private 
	{
		string _databasePath;
		sqlite3* _connection;
		Table[string] _tables;
		Statement _statement;
		public 
		{
			@system this(in string databasePath, in bool inMemory = false);

			@system ~this();

			@system void createTable(in string tableName, in string[] columns...);

			@system void createTable(in string query);

			@system void dropTable(in string tableName);

			@property @system sqlite3* connection();

			@property @system Row[] tables();

			@property @system void updateTablesList();

			@system Row[] table_info(in string tableName);

			@system Row[] command(string query);

			@system void command(string[] querys);

			@system Row[] command(string query, Variant[] values...);

			@system void command(string[] querys, Variant[][] values...);

			@system int opApply(int delegate(ref Table) dg);

			@system Table opIndex(in string name);

		}
	}
}

