// D import file generated from 'sqlite/statement.d'
module sqlite.statement;
private import std.variant;

private import std.ascii : newline;

private import std.conv;

private import std.string;

private import etc.c.sqlite3;

private import sqlite.exception;

private import sqlite.database;

debug (1)
{
	private import std.stdio;

}
struct Statement
{
	private 
	{
		sqlite3_stmt* _statement;
		char* _lineError;
		bool _isPrepared;
		int _columnCount;
		Database _database;
		@system size_t _columnType(in int column);

		@system void _bind(Variant[] values...);

		public 
		{
			bool autoExecute;
			@safe this(Database db);

			@system ~this();

			@system Row[] prepare(string query);

			@system void prepare(string[] querys);

			@system Row[] prepare(string query, Variant[] values...);

			@system void prepare(string[] querys, Variant[][] values...);

			@property @system Row[] execute();

			@property @system size_t length();

			@property @system void finalyze();

			@system string databaseName(in int column);

			@system string tableName(in int column);

			@system string originName(in int column);

			@system string columnName(in int column);

			@system Variant columnValue(in int column);

			@system int opApply(int delegate(ref int) dg);

		}
	}
}
struct Row
{
	private 
	{
		Column[] _columns;
		public 
		{
			@safe this(Column[] columns);

			@system int opApply(int delegate(ref Column) dg);

			@system int opApply(int delegate(ref size_t index, ref Column) dg);

			@property @system string toString();

			nothrow @safe Column opIndex(in size_t index);

			@system Column opIndex(in string name);

		}
	}
}
struct Column
{
	private 
	{
		Variant _value;
		string _name;
		public 
		{
			@safe this(in string name);

			@safe this(Variant value, in string name);

			nothrow @property @safe const string name();

			@property @safe template value(T)
			{
				void value(T item)
				{
					_value = item;
				}

			}

			nothrow @property @safe Variant getValue();

			nothrow @safe Variant opCall();

			@property @system const string toString();

		}
	}
}
@property @system string header(ref Row[] rows);

