// D import file generated from 'sqlite/table.d'
module sqlite.table;
private import std.string;

private import std.array;

private import std.variant;

private import sqlite.statement;

private import sqlite.database;

debug (1)
{
	private import std.stdio;

}
final class Table
{
	private 
	{
		Database _database;
		string _name;
		string _bindValues(in size_t length);
		public 
		{
			this(ref Database database, in string name);
			@system template insert(T)
			{
				void insert(ref const T[] values, ref const string[] columns = null)
				{
					string query = "";
					string bindValues = _bindValues(values.length);
					if (columns is null)
						query = "INSERT INTO `%s` VALUES ( %s )".format(_name, bindValues);
					else
						query = "INSERT INTO `%s` ( %s ) VALUES ( %s )".format(_name, columns.join(", "), bindValues);
					_database.command(query, values);
				}

			}

			@system template insert(T)
			{
				void insert(ref const T[][] values, ref const string[] columns = null)
				{
					foreach (value; values)
					{
						insert(value, columns);
					}
				}

			}

			@system template insert(T)
			{
				void insert(ref const T[][] values, ref const string[][] columns = null)
				{
					if (values.length != columns.length)
						throw new TableException(" Array values and array columns need to be same length: %s != %s".format(values.length, columns.length), "sqlite/table.d", 64);
					foreach (index; 0 .. values.length)
					{
						insert(values[index], columns[index]);
					}
				}

			}

			nothrow @system template replace(T)
			{
				void replace(ref const T[] values, ref const string[] columns = null)
				{
					string query = "";
					string bindValues = _bindValues(values.length);
					if (columns is null)
						query = "REPLACE INTO `%s` VALUES ( %s )".format(_name, bindValues);
					else
						query = "REPLACE INTO `%s` ( %s ) VALUES ( %s )".format(_name, columns.join(", "), bindValues);
					_database.command(query, values);
				}

			}

			nothrow @system template replace(T)
			{
				void replace(ref const T[][] values, ref const string[] columns = null)
				{
					foreach (ref value; values)
					{
						replace(value, columns);
					}
				}

			}

			nothrow @system template replace(T)
			{
				void replace(ref const T[][] values, ref const string[][] columns = null)
				{
					if (values.length != columns.length)
						throw new TableException(" Array values and array columns need to be same length: %s != %s".format(values.length, columns.length), "sqlite/table.d", 90);
					foreach (index; 0 .. values.length)
					{
						replace(values[index], columns[index]);
					}
				}

			}

			nothrow @system template update(T)
			{
				void update(ref const T[] values, ref const string[] columns, in string condition)
				{
					string query = "UPDATE `%s` ( %s ) SET ( %s ) WHERE %s".format(_name, columns.join(", "), condition);
					_database.command(query, values);
				}

			}

			nothrow @system template update(T)
			{
				void update(ref const T[][] values, ref const string[] columns, in string condition)
				{
					foreach (value; values)
					{
						update(value, columns, condition);
					}
				}

			}

			nothrow @system template update(T)
			{
				void update(ref const T[][] values, ref const string[][] columns, in string[] conditions)
				{
					if (columns.length != conditions.length)
						throw new TableException(" Array columns and array condition need to be same length: %s != %s".format(columns.length, conditions.length), "sqlite/table.d", 111);
					foreach (index; 0 .. columns.length)
					{
						update(values[index], columns[index], conditions[index]);
					}
				}

			}

			@system Row[] select(ref string[] column, in string statement = null);

			@system Row[] select(ref string[] column, in string statement, Variant[] values...);

		}
	}
}

